$! Check GNU m4 against examples from the manual source.
$! Copyright (C) 1992 Free Software Foundation, Inc.
$
$	pid = f$getjpi("","PID")
$	out := sys$scratch:m4-out.'pid
$	err := sys$scratch:m4-err.'pid
$	xout := sys$scratch:m4-xout.'pid
$	xerr := sys$scratch:m4-xerr.'pid
$	failed :=
$
$	on error then goto error
$
$	m4 --version
$
$	file = ""
$	old_file = ""
$ loop_files:
$	file = f$search(p1,1)
$	file = f$parse(file,,,"NAME")+f$parse(file,,,"TYPE")
$	if file .eqs. "" then goto loop_files_end
$	! if we're in a search-list, make sure we don't restart...
$	if old_file .nes. "" then -
	   if file .lts. old_file then goto loop_files_end
$	old_file = file
$
$	write sys$output "Checking ",file
$	! For some reason, defining SYS$OUTPUT /USER doesn't work.
$	! The redirection hack works a lot better.
$	define/user sys$error 'err'
$	m4 -d 'file' "--output=''out'"
$
$	_save_mess = f$env("message")
$	set message/nofacility/noseverity/noidentification/notext
$	sear 'file' "dnl @result{}" /out='xout'
$	set message'_save_mess'
$
$	open/read file1 'out'
$	open/read file2 'xout'
$	line1=""
$	line2=""
$ loop_comp_out: 
$	read/end=loop_comp_out_end/err=loop_comp_out_end file1 line1
$	read/end=loop_comp_out_fail/err=loop_comp_out_fail file2 line2
$	if "dnl @result{}"+line1 .eqs. line2 then goto loop_comp_out
$
$ loop_comp_out_fail:
$	failed = failed+" "+file+":out"
$	write sys$output file,": stdout mismatch"
$	write sys$output " `",line1,"'"
$	write sys$output " `",line2-"dnl @result{}","'"
$	diff 'out' 'xout'
$ loop_comp_out_end:
$	close file1
$	close file2
$
$	_save_mess = f$env("message")
$	set message/nofacility/noseverity/noidentification/notext
$	sear 'file' "dnl @error{}" /out='xerr'
$	set message'_save_mess'
$
$	open/read file1 'err'
$	open/read file2 'xerr'
$	line1=""
$	line2=""
$ loop_comp_err: 
$	read/end=loop_comp_err_end/err=loop_comp_err_end file1 line1
$	read/end=loop_comp_err_fail/err=loop_comp_err_fail file2 line2
$	if "dnl @error{}"+line1 .eqs. line2 then goto loop_comp_err
$
$ loop_comp_err_fail:
$	failed = failed+" "+file+":err"
$	write sys$output file,": stderr mismatch"
$	write sys$output " `",line1,"'"
$	write sys$output " `",line2-"dnl @error{}","'"
$	diff 'err' 'xerr'
$ loop_comp_err_end:
$	close file1
$	close file2
$
$	goto loop_files
$ loop_files_end:
$	delete 'out';*,'err';*,'xout';*,'xerr';*
$
$	if failed .eqs. ""
$	then
$	    write sys$output "All checks successful"
$	else
$	    write sys$output "Failed checks were:
$	    sh sym failed
$	endif
$	exit
